<template>
  <doc-alert title="用户体系" url="https://doc.iocoder.cn/user-center/" />
  <doc-alert title="三方登陆" url="https://doc.iocoder.cn/social-user/" />
  <doc-alert title="Excel 导入导出" url="https://doc.iocoder.cn/excel-import-and-export/" />

  <el-row :gutter="20">
    <!-- 左侧 设备分类 树 -->
    <el-col :span="4" :xs="24">
      <ContentWrap class="h-1/1">
        <ModelCategoryTree @node-click="handleModelCategoryTreeNodeClick" />
      </ContentWrap>
    </el-col>
    <el-col :span="20" :xs="24">
      <!-- 搜索 -->
      <div
        style="border: none; background: #fff; display: flex; align-items: center"
        class="py-2 rounded-sm px-2"
      >
        <el-form
          class="-mb-15px"
          :model="queryParams"
          ref="queryFormRef"
          :inline="true"
          label-width="68px"
        >
          <el-form-item :label="t('modelTemplate.name')" prop="name" style="margin-left: 45px">
            <el-input
              v-model="queryParams.name"
              :placeholder="t('modelTemplate.nameHolder')"
              clearable
              @keyup.enter="handleQuery"
              class="!w-240px"
            />
          </el-form-item>
          <!--          <el-form-item label="模板编码" prop="code">
            <el-input
              v-model="queryParams.code"
              placeholder="请输入模板编码"
              clearable
              @keyup.enter="handleQuery"
              class="!w-240px"
            />
          </el-form-item>-->
          <el-form-item :label="t('modelTemplate.status')" prop="status">
            <el-select
              v-model="queryParams.status"
              :placeholder="t('modelTemplate.status')"
              clearable
              class="!w-240px"
            >
              <el-option
                v-for="dict in getIntDictOptions(DICT_TYPE.COMMON_STATUS)"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item :label="t('modelTemplate.createTime')" prop="createTime">
            <el-date-picker
              v-model="queryParams.createTime"
              value-format="YYYY-MM-DD HH:mm:ss"
              type="datetimerange"
              :start-placeholder="t('operationFill.start')"
              :end-placeholder="t('operationFill.end')"
              class="!w-240px"
            />
          </el-form-item>
          <el-form-item>
            <el-button @click="handleQuery"
              ><Icon icon="ep:search" />{{ t('operationFill.search') }}</el-button
            >
            <el-button @click="resetQuery"
              ><Icon icon="ep:refresh" />{{ t('operationFill.reset') }}</el-button
            >
            <el-button
              type="primary"
              plain
              @click="openForm('create')"
              v-hasPermi="['rq:iot-model-template:create']"
            >
              <Icon icon="ep:plus" />{{ t('operationFill.add') }}
            </el-button>
          </el-form-item>
        </el-form>
      </div>
      <ContentWrap style="border: none; margin-top: 20px">
        <zm-table :loading="loading" :data="list">
          <!--          <el-table-column
            label="模板编码"
            align="center"
            prop="code"
            :show-overflow-tooltip="true"
          />-->
          <zm-table-column
            :label="t('modelTemplate.name')"
            align="center"
            prop="name"
            :show-overflow-tooltip="true"
          />
          <zm-table-column
            :label="t('modelTemplate.ec')"
            align="center"
            key="deviceCategoryName"
            prop="deviceCategoryName"
            :show-overflow-tooltip="true"
          />
          <zm-table-column :label="t('modelTemplate.status')" key="status">
            <template #default="scope">
              <el-switch
                v-model="scope.row.status"
                :active-value="0"
                :inactive-value="1"
                @change="handleStatusChange(scope.row)"
                :disabled="!checkPermi(['rq:iot-model-template:update'])"
              />
            </template>
          </zm-table-column>
          <zm-table-column
            :label="t('modelTemplate.createTime')"
            align="center"
            prop="createTime"
            :formatter="dateFormatter"
          />
          <zm-table-column :label="t('operationFill.operation')" align="center" width="220" action>
            <template #default="scope">
              <div class="flex items-center justify-center">
                <el-button
                  type="primary"
                  link
                  @click="
                    openDetail(
                      scope.row.deviceCategoryId +
                        ',' +
                        scope.row.deviceCategoryName +
                        ',' +
                        scope.row.name
                    )
                  "
                >
                  <Icon icon="ep:edit" />{{ t('operationFill.view') }}
                </el-button>
                <el-button
                  type="primary"
                  link
                  @click="openForm('update', scope.row.id)"
                  v-hasPermi="['rq:iot-model-template:update']"
                >
                  <Icon icon="ep:edit" />{{ t('modelTemplate.update') }}
                </el-button>

                <el-button
                  type="danger"
                  link
                  @click="handleDelete(scope.row.id, scope.row.deviceCategoryId)"
                  v-hasPermi="['rq:iot-model-template:delete']"
                >
                  <Icon icon="ep:delete" />{{ t('modelTemplate.delete') }}
                </el-button>
              </div>
            </template>
          </zm-table-column>
        </zm-table>
        <Pagination
          :total="total"
          v-model:page="queryParams.pageNo"
          v-model:limit="queryParams.pageSize"
          @pagination="getList"
        />
      </ContentWrap>
    </el-col>
  </el-row>

  <!-- 添加或修改 属性模板 对话框 -->
  <TemplateForm ref="formRef" :category_id="selectedId" @success="getList" />
</template>
<script lang="ts" setup>
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'
import { checkPermi } from '@/utils/permission'
import { dateFormatter } from '@/utils/formatTime'
import { CommonStatusEnum } from '@/utils/constants'
import * as ModelTemplateApi from '@/api/pms/modeltemplate'
import TemplateForm from './TemplateForm.vue'
import ModelCategoryTree from './ModelCategoryTree.vue'
import { useTreeStore } from '@/store/modules/attrTemplateTreeStore'
import { useTableComponents } from '@/components/ZmTable/useTableComponents'
const { ZmTable, ZmTableColumn } = useTableComponents()

defineOptions({ name: 'ModelAttrsTemplate' })

const treeStore = useTreeStore()
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const { push } = useRouter()
const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  name: undefined,
  code: undefined,
  status: undefined,
  deviceCategoryId: undefined,
  deviceCategoryName: undefined,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单

// 从 Store 中获取左侧 设备分类树 选中的 节点ID
const selectedId = computed(() => treeStore.selectedId)

const isInitialized = ref(false)
/** 查询 设备属性模板 列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await ModelTemplateApi.getModelTemplatePage(queryParams)
    list.value = data.list
    total.value = data.total
    // 数据加载完成后，标记为已初始化
    setTimeout(() => {
      isInitialized.value = true
    }, 100)
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields()
  handleQuery()
}

/** 处理 设备分类树 被点击 */
const handleModelCategoryTreeNodeClick = async (row) => {
  queryParams.deviceCategoryId = row.id
  await getList()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 打开详情 */
const openDetail = (id: string) => {
  push({ name: 'ModelAttrTemplate', params: { id } })
}

/** 修改 设备属性模板 状态 */
const handleStatusChange = async (row: ModelTemplateApi.ModelAttrTemplateVO) => {
  // 如果还未初始化完成，直接返回
  if (!isInitialized.value) {
    return
  }

  try {
    // 修改状态的二次确认
    const text = row.status === CommonStatusEnum.ENABLE ? '启用' : '停用'
    await message.confirm('确认要"' + text + '""' + row.name + '"属性模板吗?')
    // 发起修改状态
    await ModelTemplateApi.updateModelTemplateStatus(row.id, row.status)
    // 刷新列表
    await getList()
  } catch {
    // 取消后，进行恢复按钮
    row.status =
      row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE : CommonStatusEnum.ENABLE
  }
}

/** 操作分发 */
const handleCommand = (command: string, row: ModelTemplateApi.ModelAttrTemplateVO) => {
  switch (command) {
    case 'handleDelete':
      handleDelete(row.id, row.deviceCategoryId)
      break
    default:
      break
  }
}

/** 删除按钮操作 */
const handleDelete = async (id: number | undefined, deviceId: number) => {
  try {
    const data = await ModelTemplateApi.getIsRelated(deviceId)
    if (data.length === 0) {
      // 删除的二次确认
      await message.delConfirm()
      // 发起删除
      await ModelTemplateApi.deleteModelTemplate(id)
      message.success(t('common.delSuccess'))
    } else {
      message.error(t('form.relatedModel'))
    }

    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 */
onMounted(() => {
  getList()
})
</script>
